Index: base/src/port/port.tcl
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/base/src/port/port.tcl,v
retrieving revision 1.64
diff -u -r1.64 port.tcl
--- base/src/port/port.tcl	12 Dec 2004 01:12:27 -0000	1.64
+++ base/src/port/port.tcl	12 Dec 2004 01:51:14 -0000
@@ -463,6 +463,10 @@
 		}
 	}
 	installed {
+		# Look for recreate mode
+		set recreate [info exists options(ports_installed_recreate)]
+		
+		# If a port name is given, only look for that one, else consider all installed ports
         if { [info exists portname] } {
             if { [catch {set ilist [registry::installed $portname]} result] } {
                 if {$result == "Registry error: $portname not registered as installed."} {
@@ -492,11 +496,25 @@
                 set irevision [lindex $i 2]
                 set ivariants [lindex $i 3]
                 set iactive [lindex $i 4]
-                if { $iactive == 0 } {
-                    puts "  $iname ${iversion}_${irevision}${ivariants}"
-                } elseif { $iactive == 1 } {
-                    puts "  $iname ${iversion}_${irevision}${ivariants} (active)"
-                }
+                
+                if {$recreate} {
+                	# In recreate mode we emit a sequence of commands sufficient to reinstall the
+                	# installed ports
+                	
+                	# !!! Need to handle direct mode here, where active is always false !!!
+                	# !!! Or else (better?) the registry should be changed to know that such ports are always active !!!
+                	if { $iactive == 1 } {
+                		set variants [regsub -all {([-+])} $ivariants { \1}]
+                		puts "port install $iname$variants # ${iversion}_${irevision}"
+                	}
+                } else {
+                	# Report on the port
+					if { $iactive == 0 } {
+						puts "  $iname ${iversion}_${irevision}${ivariants}"
+					} elseif { $iactive == 1 } {
+						puts "  $iname ${iversion}_${irevision}${ivariants} (active)"
+					}
+				}
             }
         } else {
             exit 1
